## ros-humble-rig-reconfigure 1.3.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(rig_reconfigure)

set(CMAKE_CXX_STANDARD 20)

# find dependencies
find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)

# Download imgui
include(FetchContent)
FetchContent_Declare(imgui
        GIT_REPOSITORY https://github.com/ocornut/imgui.git
        GIT_TAG v1.89.8-docking
        CONFIGURE_COMMAND ""
        BUILD_COMMAND ""
        )
FetchContent_MakeAvailable(imgui)

add_library(imgui STATIC
        ${imgui_SOURCE_DIR}/imgui.cpp
        ${imgui_SOURCE_DIR}/imgui_draw.cpp
        ${imgui_SOURCE_DIR}/imgui_demo.cpp
        ${imgui_SOURCE_DIR}/imgui_tables.cpp
        ${imgui_SOURCE_DIR}/imgui_widgets.cpp
        ${imgui_SOURCE_DIR}/backends/imgui_impl_glfw.cpp
        ${imgui_SOURCE_DIR}/backends/imgui_impl_opengl3.cpp
        ${imgui_SOURCE_DIR}/misc/cpp/imgui_stdlib.cpp
        )
target_include_directories(imgui PUBLIC ${imgui_SOURCE_DIR} ${imgui_SOURCE_DIR}/backends)
find_package(glfw3 3.3 REQUIRED)
set(OpenGL_GL_PREFERENCE GLVND)
find_package(OpenGL REQUIRED)
target_link_libraries(imgui PUBLIC glfw OpenGL::GL)

add_executable(${PROJECT_NAME} src/rig_reconfigure.cpp src/service_wrapper.cpp src/parameter_tree.cpp external/lodepng/lodepng.cpp)

# uncomment for checking the executable with tsan
#target_compile_options(${PROJECT_NAME} PRIVATE -g -fsanitize=thread)
#target_link_options(${PROJECT_NAME} PRIVATE -fsanitize=thread)

target_include_directories(${PROJECT_NAME} PRIVATE include external/imspinner external/lodepng)
target_link_libraries(${PROJECT_NAME} imgui)
ament_target_dependencies(${PROJECT_NAME} rclcpp)

install(TARGETS ${PROJECT_NAME}
        DESTINATION lib/${PROJECT_NAME}
)

install(FILES resource/rig_reconfigure.png resource/rig_reconfigure_text.png
        DESTINATION share/${PROJECT_NAME}/resource
)

install(FILES resource/rig_reconfigure.svg
        DESTINATION share/icons/hicolor/scalable/apps
)

install(FILES resource/rig_reconfigure.desktop
        DESTINATION share/applications
)

ament_package()

=== debian/changelog ===
ros-humble-rig-reconfigure (1.3.2-1jammy) jammy; urgency=high

  * add dominik as maintainer
  * Contributors: Jonas Otto

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Thu, 31 Aug 2023 22:00:00 -0000

ros-humble-rig-reconfigure (1.3.1-1jammy) jammy; urgency=high

  * remove git version information in info window (#24 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/24>)
  * Contributors: Jonas Otto

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Thu, 31 Aug 2023 22:00:00 -0000

ros-humble-rig-reconfigure (1.3.0-1jammy) jammy; urgency=high

  * Only list nodes providing the parameter service (#23 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/23>)
  * Cleanup (#22 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/22>)
  * Info window (#21 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/21>)
  * Contributors: Dominik

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Tue, 29 Aug 2023 22:00:00 -0000

ros-humble-rig-reconfigure (1.2.0-1jammy) jammy; urgency=high

  * Improvements for handling string parameters (sending update only once editing is complete)
  * Add window icon
  * Add desktop file
  * Contributors: Dominik, Jonas Otto

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Thu, 10 Aug 2023 22:00:00 -0000

ros-humble-rig-reconfigure (1.1.0-1jammy) jammy; urgency=high

  * Accept more parameter path separators
  * allow scientific notation for float-parameters
  * Manual FPS limiting for VNC sessions
  * add support for string parameters
  * allow clicking on node text for folding/unfolding
  * added buttons for expanding / collapsing all parameter nodes
  * sort node names in alphabetical order
  * periodic node refreshing + warning about died nodes
  * improved sizing of the list box
  * Contributors: Dominik, Jonas Otto, Scott K Logan

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Sun, 23 Apr 2023 22:00:00 -0000

ros-humble-rig-reconfigure (1.0.0-1jammy) jammy; urgency=high

  * initial release

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Fri, 24 Feb 2023 23:00:00 -0000

=== debian/control ===
Source: ros-humble-rig-reconfigure
Section: misc
Priority: optional
Maintainer: Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>
Build-Depends: debhelper (>= 9.0.0), git, libglfw3-dev, ros-humble-ament-cmake, ros-humble-ament-index-cpp, ros-humble-rclcpp, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-rig-reconfigure
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libglfw3-dev, ros-humble-ament-index-cpp, ros-humble-rclcpp, ros-humble-ros-workspace
Description: Standalone GUI tool for editing node parameters at runtime.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-rig-reconfigure//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install

## ros-humble-rig-reconfigure 1.4.0

=== debian/changelog ===
ros-humble-rig-reconfigure (1.4.0-1bookworm) bookworm; urgency=high

  * Add dependency on ament_index_cpp to fix build on rolling (#29 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/29>)
  * Place imgui.ini within users home directory (#28 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/28>)
  * improved input handling of numeric values (#27 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/27>)
  * Contributors: Chris Lalancette, Dominik

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Tue, 26 Dec 2023 16:00:00 -0000

ros-humble-rig-reconfigure (1.3.2-1bookworm) bookworm; urgency=high

  * add dominik as maintainer
  * Contributors: Jonas Otto

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Thu, 31 Aug 2023 16:00:00 -0000

ros-humble-rig-reconfigure (1.3.1-1bookworm) bookworm; urgency=high

  * remove git version information in info window (#24 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/24>)
  * Contributors: Jonas Otto

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Thu, 31 Aug 2023 16:00:00 -0000

ros-humble-rig-reconfigure (1.3.0-1bookworm) bookworm; urgency=high

  * Only list nodes providing the parameter service (#23 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/23>)
  * Cleanup (#22 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/22>)
  * Info window (#21 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/21>)
  * Contributors: Dominik

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Tue, 29 Aug 2023 16:00:00 -0000

ros-humble-rig-reconfigure (1.2.0-1bookworm) bookworm; urgency=high

  * Improvements for handling string parameters (sending update only once editing is complete)
  * Add window icon
  * Add desktop file
  * Contributors: Dominik, Jonas Otto

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Thu, 10 Aug 2023 16:00:00 -0000

ros-humble-rig-reconfigure (1.1.0-1bookworm) bookworm; urgency=high

  * Accept more parameter path separators
  * allow scientific notation for float-parameters
  * Manual FPS limiting for VNC sessions
  * add support for string parameters
  * allow clicking on node text for folding/unfolding
  * added buttons for expanding / collapsing all parameter nodes
  * sort node names in alphabetical order
  * periodic node refreshing + warning about died nodes
  * improved sizing of the list box
  * Contributors: Dominik, Jonas Otto, Scott K Logan

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Sun, 23 Apr 2023 16:00:00 -0000

ros-humble-rig-reconfigure (1.0.0-1bookworm) bookworm; urgency=high

  * initial release

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Fri, 24 Feb 2023 16:00:00 -0000

=== debian/rules ===
--- 
+++ 
@@ -57,7 +57,7 @@
 	# in the install tree and source it.  It will set things like
 	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
 	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
-	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-rig-reconfigure//opt/ros/humble/lib/
+	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-rig-reconfigure//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-rig-reconfigure//opt/ros/humble/opt/rig_reconfigure/lib/
 
 override_dh_auto_install:
 	# In case we're installing to a non-standard location, look for a setup.sh

## ros-humble-rig-reconfigure 1.5.0

=== debian/changelog ===
ros-humble-rig-reconfigure (1.5.0-2bookworm) bookworm; urgency=high

  * create config directory if it doesnt exist (#40 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/40>)
  * Persist window size via .ini file (#36 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/36>)
  * Replace linear node list with tree representation (#34 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/34>)
  * Fixes for default parameters (#33 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/33>)
  * Contributors: Dominik, Jonas Otto

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Fri, 19 Jul 2024 16:00:00 -0000

ros-humble-rig-reconfigure (1.4.0-2bookworm) bookworm; urgency=high

  * Add dependency on ament_index_cpp to fix build on rolling (#29 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/29>)
  * Place imgui.ini within users home directory (#28 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/28>)
  * improved input handling of numeric values (#27 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/27>)
  * Contributors: Chris Lalancette, Dominik

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Tue, 26 Dec 2023 16:00:00 -0000

ros-humble-rig-reconfigure (1.3.2-2bookworm) bookworm; urgency=high

  * add dominik as maintainer
  * Contributors: Jonas Otto

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Thu, 31 Aug 2023 16:00:00 -0000

ros-humble-rig-reconfigure (1.3.1-2bookworm) bookworm; urgency=high

  * remove git version information in info window (#24 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/24>)
  * Contributors: Jonas Otto

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Thu, 31 Aug 2023 16:00:00 -0000

ros-humble-rig-reconfigure (1.3.0-2bookworm) bookworm; urgency=high

  * Only list nodes providing the parameter service (#23 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/23>)
  * Cleanup (#22 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/22>)
  * Info window (#21 <https://github.com/teamspatzenhirn/rig_reconfigure/issues/21>)
  * Contributors: Dominik

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Tue, 29 Aug 2023 16:00:00 -0000

ros-humble-rig-reconfigure (1.2.0-2bookworm) bookworm; urgency=high

  * Improvements for handling string parameters (sending update only once editing is complete)
  * Add window icon
  * Add desktop file
  * Contributors: Dominik, Jonas Otto

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Thu, 10 Aug 2023 16:00:00 -0000

ros-humble-rig-reconfigure (1.1.0-2bookworm) bookworm; urgency=high

  * Accept more parameter path separators
  * allow scientific notation for float-parameters
  * Manual FPS limiting for VNC sessions
  * add support for string parameters
  * allow clicking on node text for folding/unfolding
  * added buttons for expanding / collapsing all parameter nodes
  * sort node names in alphabetical order
  * periodic node refreshing + warning about died nodes
  * improved sizing of the list box
  * Contributors: Dominik, Jonas Otto, Scott K Logan

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Sun, 23 Apr 2023 16:00:00 -0000

ros-humble-rig-reconfigure (1.0.0-2bookworm) bookworm; urgency=high

  * initial release

 -- Team Spatzenhirn <team-spatzenhirn@uni-ulm.de>  Fri, 24 Feb 2023 16:00:00 -0000

=== debian/rules ===
--- 
+++ 
@@ -35,6 +35,7 @@
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
 		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
 		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
+		-DFETCHCONTENT_FULLY_DISCONNECTED=off       \
 		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
